﻿#region Copyright
// Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Presentation;

namespace Syncfusion.Mvc.Presentation.Web
{

    /// <summary>
    /// DocIO Extension
    /// </summary>
    public static class PresentationExtension
    {
        /// <summary>
        /// Export the document as ActionResult, returns the DocResult
        /// </summary>
        /// <param name="presentation">Presentation to serialize</param>
        /// <param name="filename">Name of the File</param>
        /// <param name="formattype">Format type of the document</param>
        /// <param name="response">Response</param>
        /// <param name="contentDisposition">HttpContentDisposition</param>
        /// <returns></returns>
        public static PresentationResult ExportAsActionResult(this IPresentation presentation, string filename, HttpResponse response)
        {
            return new PresentationResult(presentation, filename, response);
        }

    }
}
