﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Syncfusion.Mvc.Presentation.Web;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using Syncfusion.Presentation;
using Syncfusion.XlsIO;
using IOleObject = Syncfusion.Presentation.IOleObject;

namespace GenerateWord.Controllers
{
    public class HomeController : Controller
    {
        #region Generate Presentation
        public ActionResult Index(string Group1)
        {
            if (Group1 == null)
                return View();
            //Creates a new instance for ExcelEngine.
            ExcelEngine excelEngine = new ExcelEngine();

            //Get the excel file as stream
            Stream excelStream = System.IO.File.Open(ResolveApplicationDataPath("Book.xlsx"), FileMode.Open);

            //Loads or open an existing workbook through Open method of IWorkbooks
            IWorkbook workbook = excelEngine.Excel.Workbooks.Open(excelStream);

            //To-Do some manipulation

            //To-Do some manipulation

            //Set the version of the workbook.
            workbook.Version = ExcelVersion.Excel2013;

            //Set the worksheet to the instance.
            IWorksheet sheet = workbook.Worksheets[0];

            // Convert as bitmap.
            Image image = sheet.ConvertToImage(1, 1, 4, 4);

            // Save image into Stream
            MemoryStream imageStream = new MemoryStream();
            image.Save(imageStream, ImageFormat.Png);

            //Closing the workbook.
            workbook.Close();

            //Dispose the Excel engine
            excelEngine.Dispose();

            //Create new instance of PowerPoint presentation. [Equivalent to launching MS PowerPoint with no slides].
            IPresentation presentationFile = Presentation.Create();

            //Add slide with blank layout to presentation
            ISlide slide = presentationFile.Slides.Add(SlideLayoutType.Blank);

            //Add ole object to the slide
            IOleObject oleObject = slide.Shapes.AddOleObject(imageStream, "Excel.Sheet.12", excelStream);

            //Set size and position of the ole object
            oleObject.Left = 10;
            oleObject.Top = 10;
            oleObject.Width = 400;
            oleObject.Height = 300;            

            //Close the image stream.
            imageStream.Close();            

            return presentationFile.ExportAsActionResult("Output.pptx",  HttpContext.ApplicationInstance.Response);
        }
        #endregion Getting Started
        /// <summary>
        /// Data folder path is resolved from requested page physical path
        /// </summary>
        /// <param name="fileName"></param>        
        /// <returns></returns>
        protected string ResolveApplicationDataPath(string fileName)
        {
            string dataPath = null;
            dataPath = Server.MapPath(@"App_Data//").ToString();
            return string.Format("{0}\\{1}", dataPath, fileName);
        }
    }
}
